import React from 'react';

const highlightValue = (value, highlights) => {
  if (!highlights) {
    return React.createElement(
      "span",
      null,
      value
    );
  }

  const val = String(value); // deals with arrays/numbers/...

  let children = [];
  let currentPosition = 0;
  let x = 0;

  for (x = 0; x < highlights.length; x++) {
    const nonMatchingPrefix = val.slice(currentPosition, highlights[x].startIndex);
    const matchingText = val.slice(highlights[x].startIndex, highlights[x].startIndex + highlights[x].length);

    currentPosition = highlights[x].startIndex + highlights[x].length;

    if (nonMatchingPrefix.length > 0) {
      children.push(React.createElement(
        "span",
        { key: `${ x }-nonmatch` },
        nonMatchingPrefix
      ));
    }
    children.push(React.createElement(
      "span",
      { className: "highlight", key: `${ x }-match` },
      matchingText
    ));
  }
  children.push(React.createElement(
    "span",
    { key: `${ x }-remainder` },
    val.slice(currentPosition)
  ));

  return React.createElement(
    "span",
    { className: "search-result" },
    children
  );
};

export default highlightValue;